% *******************************************************
%
%             SIMULATION DE LAGRANGE ET POISSON
%
% Ce fichier initialise lagr_sim.m,
% Travail en inertiel
% *******************************************************

clear
clc

global Ir It Il etat_init Mgd wmax

wmax=1; 

% Car on trace des courbes dans le plan
% courbes contenues dans un cercle de 1 m.



% Inerties satellite en kg-m

Ir=180; % Roulis
It=180; % Tangage
Il=120; % Lacet

% Donc solide de rvolution plutt aplati

M=5;g=10;d=0.5;Mgd=M*g*d; % Dport de G et masse = M en kg

% Mgd=0; % Pour retrouver Poinsot

% ******* INITIALISATION AVEC ANGLES D'EULER**************

% Initialisation en vitesses angulaires (rd/s)

v_phi0=2*pi/5; % Soit 1 tour/s en rotation propre

v_psi0=Mgd/Il/v_phi0; % Choix de la prcession qui devrait donner
% un mouvement conique sans festons

v_teta0=0.2; % Pas de nutation initiale pour supprimer les festons


% Initialisation en position (rd)

psi0=0;
teta0=pi/3;
phi0=0;

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

vp0=v_psi0*sin(teta0)*sin(phi0)+v_teta0*cos(phi0);

vq0=psi0*sin(teta0)*cos(phi0)-v_teta0*sin(phi0);

vr0=v_phi0+v_psi0*cos(teta0);
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe  la base satellite
%  l'instant initial

Pmat(1,1)=-sin(psi0)*sin(phi0)*cos(teta0)+cos(phi0)*cos(psi0);
Pmat(1,2)=-sin(psi0)*cos(phi0)*cos(teta0)-sin(phi0)*cos(psi0);
Pmat(1,3)=sin(teta0)*sin(psi0);

Pmat(2,1)=cos(psi0)*sin(phi0)*cos(teta0)+cos(phi0)*sin(psi0);
Pmat(2,2)=cos(psi0)*cos(phi0)*cos(teta0)-sin(phi0)*sin(psi0);
Pmat(2,3)=-sin(teta0)*cos(psi0);

Pmat(3,1)=sin(teta0)*sin(phi0);
Pmat(3,2)=sin(teta0)*cos(phi0);
Pmat(3,3)=cos(teta0);

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

if 1+trac>=0,
	qt00=(1+trac)^0.5/2;
else 
	qt00=0;
end

if 1-trac+2*Pmat(1,1)>=0,
        qt10=(1-trac+2*Pmat(1,1))^0.5/2;
else
        qt10=0;
end


if 1-trac+2*Pmat(2,2)>=0,
      qt20=(1-trac+2*Pmat(2,2))^0.5/2;
else
      qt20=0;
end


if 1-trac+2*Pmat(3,3)>=0,
      qt30=(1-trac+2*Pmat(3,3))^0.5/2;
else
      qt30=0;
end

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);


elseif abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);


elseif abs(qt20)>1e-8, 

qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);


elseif abs(qt30)>1e-8,
 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);

end
Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

etat_init=[vp0 vq0 vr0 qt00 qt10 qt20 qt30];

end










